//
//  AppScaffoldAppDelegate.m
//  AppScaffold
//
//  Created by Daniel Sperl on 14.01.10.
//  Copyright Incognitek 2010. All rights reserved.
//

#import "ApplicationDelegate.h"
#import "Game.h" 

@implementation ApplicationDelegate

@synthesize window;
@synthesize sparrowView;

- (void)pauseGame 
{
	//BOOL a = adPosition == 0 && [[UIDevice currentDevice] orientation] != UIInterfaceOrientationPortrait;
    //BOOL b = adPosition == 1 && [[UIDevice currentDevice] orientation] != UIInterfaceOrientationPortraitUpsideDown;
        
	if(adPosition == 0)
	{
		[adViewController.view removeFromSuperview];
	}
	
	[mSparrowView stop];
}

- (void)resumeGame 
{	
	//BOOL a = adPosition == 0 && [[UIDevice currentDevice] orientation] != UIInterfaceOrientationPortrait;
    //BOOL b = adPosition == 1 && [[UIDevice currentDevice] orientation] != UIInterfaceOrientationPortraitUpsideDown;
        
	if(adPosition == 0)
	{
		[mWindow addSubview:adViewController.view];
	}
	
	[mSparrowView start];
}

- (void)showAd
{
	if(adViewController != nil)
	{
		[mWindow addSubview:adViewController.view];
	}
}

- (void)hideAd
{
	if(adViewController != nil)
	{
		[adViewController.view removeFromSuperview];
	}
}

void onUncaughtException(NSException *exception) 
{
	NSLog(@"Error: %@", exception.description);
}

- (void)applicationDidFinishLaunching:(UIApplication *)application 
{    
	BOOL doesAutoRotate = [AUTOROTATE];

	mSparrowView = sparrowView;
    mWindow = window;
    
    if (NSClassFromString(@"ADBannerView") != nil [IAD]) {
		NSLog(@"Loading iAds...");
		adPosition = [ADPOSITION];
		orientation = [ORIENTATION];
		
		adViewController = [[AdViewController alloc] initWithNibName:@"AdViewController" bundle:nil orientation:orientation adPosition:adPosition autorotate:doesAutoRotate];

		UIInterfaceOrientation o = [[UIApplication sharedApplication] statusBarOrientation];

		if(orientation)
		{
			BOOL a = adPosition == 0 && [[UIDevice currentDevice] orientation] != UIInterfaceOrientationLandscapeLeft;
			BOOL b = adPosition == 1 && [[UIDevice currentDevice] orientation] != UIInterfaceOrientationLandscapeRight;
			
			if(!doesAutoRotate && adPosition == 0)
			{
				a = NO;
				b = YES;
			}
        
			if(a || b)
			{
				adViewController.view.frame = CGRectMake([UIScreen mainScreen].bounds.size.width-32, 0, 32, [UIScreen mainScreen].bounds.size.height);
				
				if(UI_IDIOM() == UIUserInterfaceIdiomPad) 
				{
					adViewController.view.frame = CGRectMake([UIScreen mainScreen].bounds.size.width-66, 0, 66, [UIScreen mainScreen].bounds.size.height);
				}
			}
			
			else
			{
				adViewController.view.frame = CGRectMake(0, 0, 32, [UIScreen mainScreen].bounds.size.height);
				
				if(UI_IDIOM() == UIUserInterfaceIdiomPad) 
				{
					adViewController.view.frame = CGRectMake(0, 0, 66, [UIScreen mainScreen].bounds.size.height);
				}
			}
		}
		
		else
		{
			BOOL a = adPosition == 0 && o == UIInterfaceOrientationPortrait;
			BOOL b = adPosition == 1 && o == UIInterfaceOrientationPortraitUpsideDown;
			
			if(a || b)
			{
				adViewController.view.frame = CGRectMake(0, [UIScreen mainScreen].bounds.size.height-50, [UIScreen mainScreen].bounds.size.width, 50);
				
				if(UI_IDIOM() == UIUserInterfaceIdiomPad) 
				{
					adViewController.view.frame = CGRectMake(0, [UIScreen mainScreen].bounds.size.height-66, [UIScreen mainScreen].bounds.size.width, 66);
				}
			}
			
			else
			{
				adViewController.view.frame = CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, 50);
				
				if(UI_IDIOM() == UIUserInterfaceIdiomPad) 
				{
					adViewController.view.frame = CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, 66);
				}
			}
		}
		
		[mWindow addSubview:adViewController.view];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(pauseGame) name:@"pauseGame" object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(resumeGame) name:@"resumeGame" object:nil];
	}

    SP_CREATE_POOL(pool);    
    
    NSSetUncaughtExceptionHandler(&onUncaughtException);
    
    int gameWidth = 320;
    int gameHeight = 480;
    float currScale = [barScale];
    
    BOOL landscape = [ORIENTATION];
    
    if(landscape)
    {
    	gameHeight = 320;
    	gameWidth = 480;
    }
    
    if([[UIDevice currentDevice].model rangeOfString:@"iPad"].location == 0 && [IPADAPP])
    {
        mSparrowView.stage.width = 1024;
        mSparrowView.stage.height = 768;

		if(landscape)
		{
			gameHeight = 320;
			gameWidth = 480;
		}
		
		else
		{
			gameHeight = 480;
			gameWidth = 320;
		}
		
		currScale = 2.0;
    }
    
    int textureScale = 1;
    int viewScale = 1;
    BOOL retina = ([[UIScreen mainScreen] respondsToSelector:@selector(scale)] && [[UIScreen mainScreen] scale] == 2.0);
    
    if(UI_IDIOM() == UIUserInterfaceIdiomPad || retina)
    {
        textureScale = 2;
    }
    
    if(retina)
    {
        viewScale = 2;
    }
    
    [SPStage setContentScaleFactor:textureScale];
    [SPStage setSupportHighResolutions:YES];
    [SPAudioEngine start];
    
    Game *game = [Game alloc];
    mSparrowView.contentScaleFactor = viewScale;
    mSparrowView.stage = game;
    
    if([HASPRODUCTS])
    {
    	NSSet *productIdentifiers = [NSSet setWithObjects: [PURCHASES] nil];
    	[game initPurchases:productIdentifiers];
    }
    
    game.landscape = landscape;
    
    [game configurePreloader:[backgroundColor] barColor:[barColor] barBGColor:[barBackgroundColor] barBorderColor:[borderColor] barBorder:[borderThickness] barWidth:[barWidth] barHeight:[barHeight] barX:[barX] barY:[barY] barOffsetX:[barOffsetX] barOffsetY:[barOffsetY] barScale:[barScale] barOffsetXTablet:[barOffsetXTablet] barOffsetYTablet:[barOffsetYTablet] barScaleTablet:[barScaleTablet]];
    [game setMacAddress:@"[MACADDRESS]"];
    
    if([[UIDevice currentDevice].model rangeOfString:@"iPad"].location == 0 && [IPADAPP])
    {
        game.iPad = TRUE;
        game.iPhone = FALSE;
        
        game.largerDimension = 480;
        game.smallerDimension = 320;
    }
    
    else
    {
    	game.iPad = FALSE;
    	game.iPhone = TRUE;
    	
    	game.largerDimension = 480;
        game.smallerDimension = 320;
    }
    
    game.autoRotate = doesAutoRotate;
    
    game = [game initWithWidth:320 height:480];
    [game begin];
    
    [ACCEL_FPS]
    [game setWindow:mWindow];   
    mSparrowView.contentScaleFactor = viewScale;
    mSparrowView.stage = game;
    mSparrowView.multipleTouchEnabled = [MULTI_TOUCH];
    [FPS]
    [game release];
    
    [mWindow makeKeyAndVisible];
    [mSparrowView start];
    
    [[UIApplication sharedApplication] setIdleTimerDisabled:YES];
    
    SP_RELEASE_POOL(pool);
}

- (void)applicationWillResignActive:(UIApplication *)application 
{    
    [mSparrowView stop];
}

- (void)applicationDidBecomeActive:(UIApplication *)application 
{
	[mSparrowView start];
}

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application
{
    [SPPoint purgePool];
    [SPRectangle purgePool];
    [SPMatrix purgePool];    
}

- (void)dealloc 
{
	[[NSNotificationCenter defaultCenter] removeObserver:self name:@"pauseGame" object:nil];
	[[NSNotificationCenter defaultCenter] removeObserver:self name:@"resumeGame" object:nil];
    [adViewController release];
    
    [SPAudioEngine stop];
    [mSparrowView release];
    [mWindow release];    
    [super dealloc];
}

@end
