/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>

@class ActorType;

@interface ActorInstance : NSObject 
{
	@private
		int mElementID;
		int mX;
		int mY;
		int mLayerID;
		float mAngle;
		int mGroupID;
		int mActorID;
		BOOL mIsCustomized;
		NSMutableDictionary* mBehaviorValues;
		ActorType* mActorType;
}

-(ActorInstance*)init:(int)elementID x:(int)x y:(int)y layerID:(int)layerID angle:(float)angle groupID:(int)groupID actorID:(int)actorID behaviorValues:(NSMutableDictionary*)behaviorValues isCustomized:(BOOL)isCustomized;


//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) int elementID;
@property (nonatomic, assign) int x;
@property (nonatomic, assign) int y;
@property (nonatomic, assign) int layerID;
@property (nonatomic, assign) float angle;
@property (nonatomic, assign) int groupID;
@property (nonatomic, assign) int actorID;
@property (nonatomic, assign) BOOL isCustomized;
@property (nonatomic, assign) NSMutableDictionary* behaviorValues;
@property (nonatomic, assign) ActorType* actorType;

@end
