/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>
#import "Sparrow.h"
#import "Resource.h"


struct b2BodyDef;

#ifndef B2BODYDEF_DEFINED
typedef struct b2BodyDef b2BodyDef;
# define B2BODYDEF_DEFINED
#endif

@interface ActorType : Resource 
{
	@private
		int mGroupID;
		int mSpriteID;
		NSMutableDictionary* mBehaviorValues;
        BOOL mLightweight;
        BOOL mAutoScale;
        BOOL mPausable;
        BOOL touchable;
		#ifdef __cplusplus
		b2BodyDef* mBodyDef;
		#endif
}

- (ActorType*)init:(int)ID name:(NSString*)name groupID:(int)groupID spriteID:(int)spriteID behaviorValues:(NSMutableDictionary*)behaviorValues bodyDef:(b2BodyDef*)bodyDef lightweight:(BOOL)lightweight autoScale:(BOOL)autoScale pausable:(BOOL)pausable;

-(void)loadGraphics:(NSMutableArray*)images;
-(void)unloadGraphics;


//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) int groupID;
@property (nonatomic, assign) int spriteID;
@property (nonatomic, assign) NSMutableDictionary* behaviorValues;
@property (nonatomic, assign) BOOL lightweight;
@property (nonatomic, assign) BOOL autoScale;
@property (nonatomic, assign) BOOL pausable;
@property (nonatomic, assign) BOOL touchable;

#ifdef __cplusplus
@property (nonatomic, assign) b2BodyDef* bodyDef;
#endif

@end
