/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>

@class SPTexture;

@interface Animation : NSObject 
{
	@private
		int mAnimID;
        int mAtlasID;
		NSString* mAnimName;
		
		int mParentID;
		NSMutableDictionary* mShapes;
		BOOL mLooping;
		NSMutableArray* mDurations;
		
        //Of SPTexture*
		NSMutableArray* mImgData;
		int mImgWidth;
		int mImgHeight;
		
		int mFramesAcross;
		int mFramesDown;
    
        int mOriginX;
        int mOriginY;
}

- (Animation*)init:(int)animID atlasID:(int)atlasID animName:(NSString*)animName parentID:(int)parentID shapes:(NSMutableDictionary*)shapes looping:(BOOL)looping durations:(NSMutableArray*)durations imgData:(NSMutableArray*)imgData imgWidth:(int)imgWidth imgHeight:(int)imgHeight originX:(int)originX originY:(int)originY framesAcross:(int)framesAcross framesDown:(int)framesDown;

-(void)loadGraphics:(NSMutableArray*)images;
-(void)unloadGraphics;

//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) int atlasID;
@property (nonatomic, assign) int animID;
@property (nonatomic, assign) NSString* animName;

@property (nonatomic, assign) int parentID;
@property (nonatomic, assign) NSMutableDictionary* shapes;
@property (nonatomic, assign) BOOL looping;
@property (nonatomic, assign) NSMutableArray* durations;

@property (nonatomic, assign) NSMutableArray* imgData;
@property (nonatomic, assign) int imgWidth;
@property (nonatomic, assign) int imgHeight;

@property (nonatomic, assign) int framesAcross;
@property (nonatomic, assign) int framesDown;

@property (nonatomic, assign) int originX;
@property (nonatomic, assign) int originY;

@end
