/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>

@class ImageBackground;
@class MyViewport;
@class SPRenderSupport;

@interface Area : NSObject 
{
	@protected
		ImageBackground* mBg;
		MyViewport* mViewport;
		int mWidth;
		int mHeight;
		BOOL mRepeats;
}

- (Area*)init:(ImageBackground*)bg repeats:(BOOL)repeats width:(int)width height:(int)height;
- (void)setDimension:(int)width height:(int)height;
- (int)getWidth;
- (int)getHeight;
- (void)render:(SPRenderSupport*)g;
- (void)update;

//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) MyViewport* viewport;

@end
