/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>


@interface Attribute : NSObject 
{
	@private
		int mID;
		NSString* mFieldName;
		NSString* mFullName;
		NSString* mType;
	
		NSString* mDefaultValue;
		NSString* mValue;
		
		id mRealValue;
		void* mParent;
}

- (Attribute*)init:(int)ID fieldName:(NSString*)fieldName fullName:(NSString*)fullName value:(NSString*)value type:(NSString*)type parent:(void*)parent;
- (id)getRealValue;

//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) int ID;
@property (nonatomic, assign) NSString* fieldName;
@property (nonatomic, assign) NSString* fullName;
@property (nonatomic, assign) NSString* type;

@property (nonatomic, assign) NSString* defaultValue;
@property (nonatomic, assign) NSString* value;

@property (nonatomic, assign) id realValue;
@property (nonatomic, assign) void* parent;

@end
