/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>
#import "Sparrow.h" 

@class Script;
@class Actor;

//----------------------------------------------------------------------------------
// Interface
//----------------------------------------------------------------------------------

@interface Behavior : NSObject
{	
	@private
		NSObject* mParent;
		
		BOOL mEnabled;
		BOOL mVisible;
		
		BOOL mDrawable;
		int mDrawOrder;
		int mUpdateOrder;
		
		int mID;
		NSString* mName;
		
		NSString* mClassname;
		Class mCls;
		Script* mScript;	
		NSMutableDictionary* mAttributes;
}

- (Behavior*)init:(NSObject*)parent ID:(int)ID name:(NSString*)name classname:(NSString*)classname enabled:(BOOL)enabled visible:(BOOL)visible drawable:(BOOL)drawable attributes:(NSMutableDictionary*)attributes;

- (void)destroy;
- (void)initScript:(BOOL)initJustScript; //default is false
- (void)initAttributes;

- (void)update;
- (void)render:(SPRenderSupport*)g x:(int)x y:(int)y;


//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) NSObject* parent;

@property (nonatomic, assign) BOOL enabled;
@property (nonatomic, assign) BOOL visible;

@property (nonatomic, assign) BOOL drawable;
@property (nonatomic, assign) int drawOrder;
@property (nonatomic, assign) int updateOrder;

@property (nonatomic, assign) int ID;
@property (nonatomic, assign) NSString* name;

@property (nonatomic, assign) NSString* classname;
@property (nonatomic, assign) Class cls;
@property (nonatomic, assign) Script* script;
@property (nonatomic, assign) NSMutableDictionary* attributes;

@end
