/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>

@class Actor;

@interface Collision : NSObject 
{
	@private
		BOOL mFromTop;
		BOOL mFromLeft;
		BOOL mfromBottom;
		BOOL mFromRight;
		
		BOOL mCollidedWithActor;
		BOOL mCollidedWithTile;
		BOOL mCollidedWithSensor;
        BOOL mCollidedWithTerrain;
		
		//of CollisionPoint*
		NSMutableArray* mPoints;
		
		Actor* mThisActor;
		Actor* mOtherActor;
		
		#ifdef __cplusplus
		b2Fixture* thisShape;
		b2Fixture* otherShape;
		#endif
		
		Actor* actorA;
		Actor* actorB;
}

-(Collision*)init;

+(BOOL)fromTop:(Collision*)c actor:(Actor*)a;
+(BOOL)fromLeft:(Collision*)c actor:(Actor*)a;
+(BOOL)fromBottom:(Collision*)c actor:(Actor*)a;
+(BOOL)fromRight:(Collision*)c actor:(Actor*)a;

+(BOOL)collidedWithActor:(Collision*)c actor:(Actor*)a;
+(BOOL)collidedWithTile:(Collision*)c actor:(Actor*)a;
+(BOOL)collidedWithSensor:(Collision*)c actor:(Actor*)a;
+(BOOL)collidedWithTerrain:(Collision*)c actor:(Actor*)a;

+(NSMutableArray*)points:(Collision*)c actor:(Actor*)a;
+(Actor*)thisActor:(Collision*)c actor:(Actor*)a;
+(Actor*)otherActor:(Collision*)c actor:(Actor*)a;
+(Actor*)actorA:(Collision*)c actor:(Actor*)a;
+(Actor*)actorB:(Collision*)c actor:(Actor*)a;

//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) BOOL fromTop;
@property (nonatomic, assign) BOOL fromLeft;
@property (nonatomic, assign) BOOL fromBottom;
@property (nonatomic, assign) BOOL fromRight;

@property (nonatomic, assign) BOOL collidedWithActor;
@property (nonatomic, assign) BOOL collidedWithTile;
@property (nonatomic, assign) BOOL collidedWithSensor;
@property (nonatomic, assign) BOOL collidedWithTerrain;

@property (nonatomic, assign) NSMutableArray* points;

@property (nonatomic, assign) Actor* thisActor;
@property (nonatomic, assign) Actor* otherActor;

#ifdef __cplusplus
@property (nonatomic, assign) b2Fixture* thisShape;
@property (nonatomic, assign) b2Fixture* otherShape;
#endif

@property (nonatomic, assign) Actor* actorA;
@property (nonatomic, assign) Actor* actorB;
@end
