/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>
#import "Area.h"

@class SPRenderSupport;

@interface ParallaxArea : Area 
{
	@private
		NSMutableArray* mBackLayers;
		NSMutableArray* mForeLayers;
		int mSceneWidth;
		int mSceneHeight;
}

- (ParallaxArea*)init:(int)sceneWidth sceneHeight:(int)sceneHeight;
- (void)addForegroundLayer:(Area*)layer;
- (void)addBackgroundLayer:(Area*)layer;
- (void)normalizeAllLayers;
- (void)normalizeLayers:(NSArray*)layers;
- (void)drawBackgrounds:(SPRenderSupport*)g;
- (void)drawForegrounds:(SPRenderSupport*)g;
- (void)update;


//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) NSMutableArray* backLayers;
@property (nonatomic, assign) NSMutableArray* foreLayers;

@end
