/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>
#import "Actor.h"

@interface Region : Actor 
{
	@private
		BOOL mIsCircle;
		BOOL mFlag;
		
		NSMutableSet* mContains;

		#ifdef __cplusplus
		b2Shape* mCopy;
		#endif
	
        float mActualWidth;
        float mActualHeight;
		int mOriginalWidth;
		int mOriginalHeight;
    
        NSMutableArray* mWhenActorEntersListeners;
        NSMutableArray* mWhenActorExitsListeners;
    
        NSMutableArray* mJustAdded;
        NSMutableArray* mJustRemoved;
}

-(Region*)init:(float)x y:(float)y shapes:(NSMutableArray*)shapes;
-(BOOL)containsActor:(Actor*)actor;
-(NSMutableSet*)getContainedActors;
-(void)addActor:(Actor*)actor;
-(void)removeActor:(Actor*)actor;
-(void)follow:(Actor*)actor;
-(void)resetSize;
-(void)setRegionDiameter:(int)diameter;
-(void)setRegionSize:(int)width height:(int)height;
-(void)setLocation:(int)x y:(int)y;
-(int)getWidth;
-(int)getHeight;


//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) BOOL isCircle;
@property (nonatomic, assign) BOOL flag;

@property (nonatomic, assign) NSMutableSet* contains;

#ifdef __cplusplus
@property (nonatomic, assign) b2Shape* copy;
#endif

@property (nonatomic, assign) int originalWidth;
@property (nonatomic, assign) int originalHeight;

@property (nonatomic, assign) NSMutableArray* whenActorEntersListeners;
@property (nonatomic, assign) NSMutableArray* whenActorExitsListeners;

@end
