/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>
#import "ImageBackground.h"

@interface ScrollingBackground : ImageBackground 
{
	@private
		double mXVelocity;
		double mYVelocity;
}

-(ScrollingBackground*)init:(int)ID name:(NSString *)name image:(SPTexture*)image repeats:(BOOL)repeats xVelocity:(double)xVelocity yVelocity:(double)yVelocity;

-(void)loadGraphics:(SPTexture*)image;
-(void)unloadGraphics;

@property (nonatomic, assign) double xVelocity;
@property (nonatomic, assign) double yVelocity;

@end
