#import "SoundChannel.h"
#import "Sparrow.h"


@interface SoundChannel : NSObject 
{
    @private
        SPSoundChannel* mCurrentSound;
        SPSound* mCurrentSource;
    
        float mVolume;
        int mChannelNum;
}

-(SoundChannel*)initWithChannelNum:(int)channelNum;

-(SPSoundChannel*)playSound:(SPSound*)sound;
-(SPSoundChannel*)loopSound:(SPSound*)sound;

-(void)setPause:(BOOL)pause;
-(void)stopSound;

-(void)fadeInSound:(float)time;
-(void)fadeOutSound:(float)time;
-(void)setVolume:(float)volume;

//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) SPSoundChannel* currentSound;
@property (nonatomic, assign) SPSound* currentSource;
@property (nonatomic, assign) float volume;
@property (nonatomic, assign) int channelNum;

@end

