/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>
#import "Sparrow.h"
#import "Resource.h"

@interface Sprite : Resource 
{
	@private
		int mWidth;
		int mHeight;
		int mDefaultAnimation;
		NSMutableDictionary* mAnimations;
}

- (Sprite*)init:(int)ID name:(NSString*)name width:(int)width height:(int)height defaultAnimation:(int)defaultAnimation;

-(void)loadGraphics:(NSMutableArray*)images;
-(void)unloadGraphics;


//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) int width;
@property (nonatomic, assign) int height;
@property (nonatomic, assign) int defaultAnimation;
@property (nonatomic, assign) NSMutableDictionary* animations;

@end
