/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>
#import "AbstractReader.h"

@class Sprite;
@class Animation;

@interface SpriteReader : AbstractReader 
{
}

-(Animation*)readAnimation:(TBXMLElement*)xml parent:(Sprite*)parent atlasID:(int)atlasID;
-(NSMutableDictionary*)readShapes:(TBXMLElement*)xml imgWidth:(int)imgWidth imgHeight:(int)imgHeight;

#ifdef __cplusplus
+(b2Shape*)createShape:(NSString*)shapeType params:(NSArray*)params xOffset:(int)xOffset yOffset:(int)yOffset imgWidth:(int)imgWidth imgHeight:(int)imgHeight;
+(b2PolygonShape*)decomposeShape:(NSArray*)params;
+(float)getWidth:(b2Vec2*)vertices numVertices:(int)numVertices;
+(float)getHeight:(b2Vec2*)vertices numVertices:(int)numVertices;
#endif

@end
