/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>
#import "Actor.h"

@interface TerrainRegion : Actor 
{
    @private
        BOOL mIsCircle;
        BOOL mFlag;

        #ifdef __cplusplus
        b2Shape* mCopy;
        #endif
        
        int mOriginalWidth;
        int mOriginalHeight;
}

-(TerrainRegion*)init:(float)x y:(float)y shapes:(NSMutableArray*)shapes;
-(void)follow:(Actor*)actor;
-(void)resetSize;
-(void)setTerrainRegionDiameter:(int)diameter;
-(void)setTerrainRegionSize:(int)width height:(int)height;
-(void)setLocation:(int)x y:(int)y;
-(int)getWidth;
-(int)getHeight;


//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) BOOL isCircle;
@property (nonatomic, assign) BOOL flag;

#ifdef __cplusplus
@property (nonatomic, assign) b2Shape* copy;
#endif

@property (nonatomic, assign) int originalWidth;
@property (nonatomic, assign) int originalHeight;

@end

