/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import <Foundation/Foundation.h>
#import "Sparrow.h"
#import "SPCompiledSprite.h"

@class Scene;
@class Tile;

@interface TileLayer : SPCompiledSprite 
{
	@private
		int mOrder;
		int mID;
		//already comes with a name
	
		NSMutableArray* mRows;
		Scene* mScene;
		int mNumRows;
		int mNumCols;
}

-(TileLayer*)init:(int)ID order:(int)order scene:(Scene*)scene numCols:(int)numCols numRows:(int)numRows;

-(void)setTileAt:(int)row col:(int)col tile:(Tile*)tile;
-(Tile*)getTileAt:(int)row col:(int)col;
-(void)draw:(SPRenderSupport*)support viewX:(int)viewX viewY:(int)viewY alpha:(float)alpha;
-(void)predraw;


//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) int ID;
@property (nonatomic, assign) int order;
@property (nonatomic, assign) SPImage* cache;


@end
