/*
 * ----------------------------------------------------------------------------------
 * Copyright (c) 2008-2011, Stencyl, LLC
 * ----------------------------------------------------------------------------------
 * All rights reserved.
 * ----------------------------------------------------------------------------------
 */

#import "Sparrow.h"
#import <Foundation/Foundation.h>
#import "Resource.h"

@class Rectangle;

@interface Tileset : Resource 
{
	@private
		int mFramesAcross;
		int mFramesDown;
		NSMutableDictionary* mTiles;
		SPTexture* mPixels;
}

- (Tileset*)init:(int)ID name:(NSString *)name framesAcross:(int)framesAcross framesDown:(int)framesDown tiles:(NSMutableDictionary*)tiles pixels:(SPTexture*)pixels;
- (SPRectangle*)getImageSourceForTile:(int)tileID tileWidth:(int)tileWidth tileHeight:(int)tileHeight;


//----------------------------------------------------------------------------------
// Properties
//----------------------------------------------------------------------------------

@property (nonatomic, assign) int framesAcross;
@property (nonatomic, assign) int framesDown;
@property (nonatomic, assign) NSMutableDictionary* tiles;
@property (nonatomic, assign) SPTexture* pixels;

@end
